package org.jvnet.hifaces.component.html;

import javax.faces.component.html.HtmlOutputLink;
import javax.faces.context.FacesContext;
import javax.faces.el.ValueBinding;

import org.apache.myfaces.shared.util._ComponentUtils;

public class HtmlOpenWindowLink extends HtmlOutputLink {

	public static final String COMPONENT_TYPE = "org.jvnet.hifaces.HtmlOpenWindowLink";

	private static final String DEFAULT_RENDERER_TYPE = "org.jvnet.hifaces.OpenWindowLink";

	public HtmlOpenWindowLink() {
		setRendererType(DEFAULT_RENDERER_TYPE);
	}

	private String _windowName;

	private String _windowFeatures;

	private String _windowReplace;

	public void setWindowName(String windowName) {
		_windowName = windowName;
	}

	public String getWindowName() {
		if (_windowName != null)
			return _windowName;
		ValueBinding vb = getValueBinding("windowName");
		return vb != null ? _ComponentUtils.getStringValue(getFacesContext(),
				vb) : null;
	}

	public void setWindowFeatures(String windowFeatures) {
		_windowFeatures = windowFeatures;
	}

	public String getWindowFeatures() {
		if (_windowFeatures != null)
			return _windowFeatures;
		ValueBinding vb = getValueBinding("windowFeatures");
		return vb != null ? _ComponentUtils.getStringValue(getFacesContext(),
				vb) : null;
	}

	public void setWindowReplace(String windowReplace) {
		_windowReplace = windowReplace;
	}

	public String getWindowReplace() {
		if (_windowReplace != null)
			return _windowReplace;
		ValueBinding vb = getValueBinding("windowReplace");
		return vb != null ? _ComponentUtils.getStringValue(getFacesContext(),
				vb) : null;
	}

	public Object saveState(FacesContext context) {
		Object values[] = new Object[4];
		values[0] = super.saveState(context);
		values[1] = _windowName;
		values[2] = _windowFeatures;
		values[3] = _windowReplace;
		return ((Object) (values));
	}

	public void restoreState(FacesContext context, Object state) {
		Object values[] = (Object[]) state;
		super.restoreState(context, values[0]);
		_windowName = (String) values[1];
		_windowFeatures = (String) values[2];
		_windowReplace = (String) values[3];
	}
}
