package org.jvnet.hifaces.counter;

import java.io.Serializable;
import java.util.Map;

import javax.faces.context.FacesContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

public class Counter implements Serializable {

	private static final long serialVersionUID = 1L;

	private long counter = 0;

	public synchronized Long nextId() {
		counter = counter + 1;
		return counter;
	}

	public static Counter getCounter(HttpServletRequest request,
			String counterName) {
		final HttpSession session = request.getSession();

		final Object draftCounter = session.getAttribute(counterName);

		if (draftCounter instanceof Counter) {
			return (Counter) draftCounter;
		} else {
			final Counter counter = new Counter();
			session.setAttribute(counterName, counter);
			return counter;
		}
	}
	
	public static Counter getCounter(FacesContext facesContext,
			final String counterName) {
		final Map sessionMap = facesContext.getExternalContext()
				.getSessionMap();
		final Object draftCounter = sessionMap.get(counterName);

		if (draftCounter instanceof Counter) {
			return (Counter) draftCounter;
		} else {
			final Counter counter = new Counter();
			sessionMap.put(counterName, counter);
			return counter;
		}
	}

	public static Counter getCounter(final String counterName) {
		return getCounter(FacesContext.getCurrentInstance(), counterName);
	}	

}
