package org.jvnet.hifaces.text;

import javax.faces.context.FacesContext;

import org.apache.commons.lang.Validate;
import org.springframework.context.MessageSourceResolvable;

public class ResolvingText extends AbstractSingularText {

	private final MessageSourceResolvable messageSourceResolveable;

	public ResolvingText(final MessageSourceResolvable messageSourceResolveable) {
		Validate
				.notNull(messageSourceResolveable, "Argument must not be null.");
		this.messageSourceResolveable = messageSourceResolveable;
	}

	@Override
	protected String getMessageId(FacesContext facesContext) {
		return messageSourceResolveable.getCodes()[0];
	}

	@Override
	protected Object[] getArguments(FacesContext facesContext) {
		return messageSourceResolveable.getArguments();
	}

	@Override
	protected String getDefaultMessage(String messageId) {
		return messageSourceResolveable.getDefaultMessage();
	}
}
