package org.jvnet.hifaces.util;

import java.util.Collection;

import javax.faces.component.UIComponent;
import javax.faces.component.html.HtmlPanelGrid;
import javax.faces.component.html.HtmlPanelGroup;

import org.apache.commons.lang.Validate;

public class PanelUtils {

	private PanelUtils() {

	}

	public static HtmlPanelGrid createPanelGrid() {
		final HtmlPanelGrid panelGrid = new HtmlPanelGrid();
		IdUtils.assignId(panelGrid);
		return panelGrid;
	}
	
	public static HtmlPanelGrid createPanelGrid(UIComponent... components) {
		Validate.noNullElements(components, "Collections should not contain null elements.");
		final HtmlPanelGrid grid = PanelUtils.createPanelGrid();
		grid.setColumns(components.length);
		return ComponentUtils.addChildren(grid,
				components);
	}

	public static HtmlPanelGrid createPanelGrid(Collection<UIComponent> components) {
		Validate.noNullElements(components, "Collections should not contain null elements.");
		final HtmlPanelGrid grid = PanelUtils.createPanelGrid();
		grid.setColumns(components.size());
		return ComponentUtils.addChildren(grid,
				components);
	}
	

	public static HtmlPanelGroup createPanelGroup() {
		final HtmlPanelGroup panelGroup = new HtmlPanelGroup();
		IdUtils.assignId(panelGroup);
		return panelGroup;
	}

	public static HtmlPanelGroup createPanelGroup(UIComponent... components) {
		return ComponentUtils.addChildren(PanelUtils.createPanelGroup(),
				components);
	}

	public static HtmlPanelGroup createPanelGroup(Collection<UIComponent> components) {
		return ComponentUtils.addChildren(PanelUtils.createPanelGroup(),
				components);
	}
}
